/*
 * Programmieren fuer Physiker, SS 2023, Blatt 7, Aufgabe 18
 *
 * Struct fuer Minuten und Sekunden
 */

#include <iostream>
using namespace std ;

struct minsek
{
    int min ;
    int sek ;
} ;

// Eingeben
minsek get_minsek() 
{
    minsek t ;
    cout << "Minuten und Sekunden bitte: " ;
    cin >> t.min >> t.sek ;
    return t ;
}

// Ausgeben
void print_minsek( minsek t) 
{
    cout << "Zeit: " << t.min << ":" << t.sek << endl ;
    return ; // this is not really necessary, here.
}

// Zeiten addieren
minsek add_minsek( minsek t1, minsek t2) 
{
    minsek sum ;
    sum.sek = (t1.sek + t2.sek)%60 ;
    sum.min = t1.min + t2.min + (t1.sek + t2.sek)/60 ; 
    return sum ;
}

// Zeiten addieren mit Operator-Syntax
minsek operator+( minsek t1, minsek t2) 
{
    minsek sum ;
    sum.sek = (t1.sek + t2.sek)%60 ;
    sum.min = t1.min + t2.min + (t1.sek + t2.sek)/60 ; 
    return sum ;
}

int main()
{
    cout << "Minsek-Struct" << endl ;
    minsek zeit1 = get_minsek() ;
    minsek zeit2 = get_minsek() ;
    // minsek zeitsumme = add_minsek(zeit1, zeit2) ;
    minsek zeitsumme = zeit1 + zeit2 ;
    cout << "Die Summe ist: " << endl ;
    print_minsek(zeitsumme) ;
}
